package com.example.config;

import com.example.utils.AESUtil;
import io.swagger.v3.oas.models.OpenAPI;
import io.swagger.v3.oas.models.info.Info;
import io.swagger.v3.oas.models.parameters.Parameter;
import org.springdoc.core.customizers.OpenApiCustomiser;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * api文档配置
 */
@Configuration
public class ApiDocConfig {
    @Bean
    public OpenAPI openapi() {
        return new OpenAPI().info(new Info().title("财务接口").description("财务接口文档").version("1.0"));
    }

    @Bean
    public OpenApiCustomiser openApiCustomiser() {
        String token = AESUtil.getTestToken();
        return openApi -> openApi.getPaths().values()
                .forEach(pathItem -> pathItem.readOperations()
                        .forEach(operation -> {
                            Parameter headerParam = new Parameter()
                                    .required(true)
                                    .in("header")
                                    .name("token")
                                    .description("访问令牌")
                                    .example(token);
                            operation.addParametersItem(headerParam);
                        }));
    }
}