package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.WzDataInspectionEntity;
import com.example.service.WzDataInspectionService;
import com.example.utils.PageMap;
import com.example.utils.PageUtils;
import com.example.utils.Query;
import com.example.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 房屋出租(合同管理)
 */
@RestController
@RequestMapping("/house-car/house/dist/api/WzDataInspection")
public class WzDataInspectionController {

    @Autowired
    private WzDataInspectionService wzDataInspectionService;

    @RequestMapping("/list")
    @IgnoreAuth
    public R list(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        List<WzDataInspectionEntity> list = wzDataInspectionService.queryList(query);
        Query query1 = new Query(pageMap);
        int total = wzDataInspectionService.queryTotal(query1);
        PageUtils pageUtil = new PageUtils(list, total, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

}
