package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.OtnAreaEntity;
import com.example.entity.WzHouseContracEntity;
import com.example.entity.WzHouseContractCompareEntity;
import com.example.entity.WzHouseContractInEntity;
import com.example.entity.WzHouseContractTopEntity;
import com.example.entity.WzHouseLeaseInConEntity;
import com.example.entity.WzHouseUseEntity;
import com.example.entity.vo.WzHouseUseVo;
import com.example.service.WzHouseContractCompareService;
import com.example.service.WzHouseContractInService;
import com.example.service.WzHouseContractTopService;
import com.example.service.WzHouseLeaseInConService;
import com.example.service.WzHouseUseService;
import com.example.service.WzOtnAreaService;
import com.example.utils.PageMap;
import com.example.utils.PageUtils;
import com.example.utils.Query;
import com.example.utils.R;
import com.example.utils.excel.ExcelExport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 房屋租入(合同管理)
 */
@RestController
@RequestMapping("/house-car/house/dist/api/WzHouseLeaseInCon")
public class WzHouseLeaseInConController {

    @Autowired
    private WzHouseContractTopService wzHouseContractTopService;
    @Autowired
    private WzHouseContractCompareService wzHouseContractCompareService;
    @Autowired
    private WzHouseLeaseInConService wzHouseLeaseInConService;
    @Autowired
    private WzHouseContractInService wzHouseContractInService;
    @Autowired
    private WzHouseUseService wzHouseUseService;
    @Autowired
    private WzOtnAreaService otnAreaService;

    @RequestMapping("/list")
    @IgnoreAuth
    public R list(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        List<WzHouseContracEntity> list = wzHouseLeaseInConService.queryList(pageMap.getMap());
        int total = wzHouseLeaseInConService.queryTotal(query);
        PageUtils pageUtil = new PageUtils(list, total, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

    @RequestMapping("/echartList")
    @IgnoreAuth
    public R echartList(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        List<WzHouseLeaseInConEntity> wzHouseContracEntityList = wzHouseLeaseInConService.queryList(pageMap.getMap());

        Map<String,List<WzHouseLeaseInConEntity>> cityMap=new HashMap<>();
        for (WzHouseLeaseInConEntity leaveUseVo : wzHouseContracEntityList) {
            List<WzHouseLeaseInConEntity> list;
            if(cityMap.get(leaveUseVo.getStandardAddressLevel2())!=null){
                list=cityMap.get(leaveUseVo.getStandardAddressLevel2());
                list.add(leaveUseVo);
            }else{
                list=new ArrayList<>();
                list.add(leaveUseVo);
            }
            cityMap.put(leaveUseVo.getStandardAddressLevel2(),list);
        }

        List<WzHouseLeaseInConEntity> resultList=new ArrayList<>();
        List<WzHouseLeaseInConEntity> cityList=new ArrayList<>();

        double allContractQuantity=0l;            // 租入合同数量
        double allNoTaxContractAmount=0l;         // 合同总金额（含税）（元）
        double allRentArea=0l;                    // 总计面积（平米）
        double allUnitPricePerSquareMeter=0l;     // 每平米单价

         double allbusinessAreaSquaMete=0l;            //营业面积（平米）
         double allofficeAreaSquaMete=0l;              //办公面积（平米）
         double allcommunicationRoomAreaSquaMete=0l;  //通信机房面积（平米）
         double allotherUsageAreaSquaMete=0l;         //其他用途面积（平米）

        int cityNum=0;
        for(Map.Entry<String,List<WzHouseLeaseInConEntity>> entry:cityMap.entrySet()){
            List<WzHouseLeaseInConEntity> list=entry.getValue();

            if (list.get(0).getStandardAddressLevel3().equals("全省")) {
                continue;
            }
            //县的Map集合
            Map<String, List<WzHouseLeaseInConEntity>> countyMap = new HashMap<>();
            for (WzHouseLeaseInConEntity leaveUseVo : list) {
                if (leaveUseVo.getStandardAddressLevel3() == null || leaveUseVo.getStandardAddressLevel3().equals("")) {
                    continue;
                }
                if (countyMap.get(leaveUseVo.getStandardAddressLevel3()) != null) {
                    list = countyMap.get(leaveUseVo.getStandardAddressLevel3());
                    list.add(leaveUseVo);
                } else {
                    list = new ArrayList<>();
                    list.add(leaveUseVo);
                }
                countyMap.put(leaveUseVo.getStandardAddressLevel3(), list);
            }

            double cityContractQuantity=0l;
            double cityNoTaxContractAmount=0l;
            double cityRentArea=0l;
            double cityUnitPricePerSquareMeter=0l;

            double citybusinessAreaSquaMete=0l;            //营业面积（平米）
            double cityofficeAreaSquaMete=0l;              //办公面积（平米）
            double citycommunicationRoomAreaSquaMete=0l;  //通信机房面积（平米）
            double cityotherUsageAreaSquaMete=0l;         //其他用途面积（平米）
            List<WzHouseLeaseInConEntity> countyList=new ArrayList<>();
            for (Map.Entry<String, List<WzHouseLeaseInConEntity>> countyEntry : countyMap.entrySet()) {
                double contractQuantity=0l;
                double noTaxContractAmount=0l;
                double rentArea=0l;
                double unitPricePerSquareMeter=0l;

                double businessAreaSquaMete=0l;            //营业面积（平米）
                double officeAreaSquaMete=0l;              //办公面积（平米）
                double communicationRoomAreaSquaMete=0l;  //通信机房面积（平米）
                double otherUsageAreaSquaMete=0l;         //其他用途面积（平米）
                for (WzHouseLeaseInConEntity leaveUseVo : countyEntry.getValue()) {
                    contractQuantity+=leaveUseVo.getLeaInContracQuantity();
                    noTaxContractAmount+=leaveUseVo.getTotalContrAmount();
                    rentArea+=leaveUseVo.getTotalAreaSquaMete();
                    unitPricePerSquareMeter+=leaveUseVo.getUnitPricePerSquareMeter();
                     businessAreaSquaMete+= leaveUseVo.getBusinessAreaSquaMete();
                     officeAreaSquaMete+=leaveUseVo.getOfficeAreaSquaMete();
                     communicationRoomAreaSquaMete+=leaveUseVo.getCommunicationRoomAreaSquaMete();
                     otherUsageAreaSquaMete+=leaveUseVo.getOtherUsageAreaSquaMete();

                    cityContractQuantity+=leaveUseVo.getLeaInContracQuantity();
                    cityNoTaxContractAmount+=leaveUseVo.getTotalContrAmount();
                    cityRentArea+=leaveUseVo.getTotalAreaSquaMete();
                    cityUnitPricePerSquareMeter+=leaveUseVo.getUnitPricePerSquareMeter();
                    citybusinessAreaSquaMete+= leaveUseVo.getBusinessAreaSquaMete();
                    cityofficeAreaSquaMete+=leaveUseVo.getOfficeAreaSquaMete();
                    citycommunicationRoomAreaSquaMete+=leaveUseVo.getCommunicationRoomAreaSquaMete();
                    cityotherUsageAreaSquaMete+=leaveUseVo.getOtherUsageAreaSquaMete();

                    allContractQuantity+=leaveUseVo.getLeaInContracQuantity();
                    allNoTaxContractAmount+=leaveUseVo.getTotalContrAmount();
                    allRentArea+=leaveUseVo.getTotalAreaSquaMete();
                    allUnitPricePerSquareMeter+=leaveUseVo.getUnitPricePerSquareMeter();
                    allbusinessAreaSquaMete+= leaveUseVo.getBusinessAreaSquaMete();
                    allofficeAreaSquaMete+=leaveUseVo.getOfficeAreaSquaMete();
                    allcommunicationRoomAreaSquaMete+=leaveUseVo.getCommunicationRoomAreaSquaMete();
                    allotherUsageAreaSquaMete+=leaveUseVo.getOtherUsageAreaSquaMete();
                }
                WzHouseLeaseInConEntity wzHouseInCustomerEntity = new WzHouseLeaseInConEntity();
                wzHouseInCustomerEntity.setLeaInContracQuantity(formatDouble(contractQuantity));
                wzHouseInCustomerEntity.setStandardAddressLevel2(countyEntry.getKey());
                wzHouseInCustomerEntity.setTotalContrAmount(formatDouble(noTaxContractAmount));
                wzHouseInCustomerEntity.setTotalAreaSquaMete(formatDouble(rentArea));
                wzHouseInCustomerEntity.setUnitPricePerSquareMeter(formatDouble(unitPricePerSquareMeter));
                wzHouseInCustomerEntity.setBusinessAreaSquaMete(formatDouble(businessAreaSquaMete));
                wzHouseInCustomerEntity.setOfficeAreaSquaMete(formatDouble(officeAreaSquaMete));
                wzHouseInCustomerEntity.setCommunicationRoomAreaSquaMete(formatDouble(communicationRoomAreaSquaMete));
                wzHouseInCustomerEntity.setOtherUsageAreaSquaMete(formatDouble(otherUsageAreaSquaMete));
                countyList.add(wzHouseInCustomerEntity);
            }
            List<WzHouseLeaseInConEntity> orderCountyList=new ArrayList<>();
            try{
                //对countList 进行排序
                String city=list.get(0).getStandardAddressLevel2();
                if(city.contains("市")){
                    city=city.split("市")[0];
                }
                OtnAreaEntity area=otnAreaService.queryObject(city);
                List<OtnAreaEntity> countyAreaList=otnAreaService.getCityOption(area.getId());
                int i=0;
                for (OtnAreaEntity otnAreaEntity : countyAreaList) {
                    for (WzHouseLeaseInConEntity wzCity : countyList) {
                        if(wzCity.getStandardAddressLevel2().contains(otnAreaEntity.getName())){
                            i++;
                            wzCity.setFlag(i%2==0);
                            orderCountyList.add(wzCity);
                        }
                    }
                }
            }catch (Exception e){
                orderCountyList=countyList;
                e.printStackTrace();
            }

            WzHouseLeaseInConEntity wzHouseInCustomerEntity = new WzHouseLeaseInConEntity();
            wzHouseInCustomerEntity.setStandardAddressLevel2(entry.getKey());
            wzHouseInCustomerEntity.setLeaInContracQuantity(formatDouble(cityContractQuantity));
            wzHouseInCustomerEntity.setTotalContrAmount(formatDouble(cityNoTaxContractAmount));
            wzHouseInCustomerEntity.setTotalAreaSquaMete(formatDouble(cityRentArea));
            wzHouseInCustomerEntity.setBusinessAreaSquaMete(formatDouble(citybusinessAreaSquaMete));
            wzHouseInCustomerEntity.setOfficeAreaSquaMete(formatDouble(cityofficeAreaSquaMete));
            wzHouseInCustomerEntity.setCommunicationRoomAreaSquaMete(formatDouble(citycommunicationRoomAreaSquaMete));
            wzHouseInCustomerEntity.setOtherUsageAreaSquaMete(formatDouble(cityotherUsageAreaSquaMete));
            double num=cityUnitPricePerSquareMeter/countyMap.size();
            cityNum+=countyMap.size();
            wzHouseInCustomerEntity.setUnitPricePerSquareMeter(formatDouble(num));
            wzHouseInCustomerEntity.setChildren(orderCountyList);
            cityList.add(wzHouseInCustomerEntity);
        }


        //对cityList 进行排序
        List<OtnAreaEntity> areaList=otnAreaService.getCityOption("018");
        List<WzHouseLeaseInConEntity> orderList=new ArrayList<>();
        int i=0;
        for (OtnAreaEntity otnAreaEntity : areaList) {
            for (WzHouseLeaseInConEntity wzCity : cityList) {
                if(wzCity.getStandardAddressLevel2().contains(otnAreaEntity.getName())){
                    wzCity.setFlag(i%2==0);
                    i++;
                    orderList.add(wzCity);
                }
            }
        }

        WzHouseLeaseInConEntity province=new WzHouseLeaseInConEntity();
        province.setStandardAddressLevel2("全省");
        province.setLeaInContracQuantity(formatDouble(allContractQuantity));
        province.setTotalContrAmount(formatDouble(allNoTaxContractAmount));
        province.setTotalAreaSquaMete(formatDouble(allRentArea));
        if(cityList.size()!=0){
            province.setUnitPricePerSquareMeter(formatDouble(allUnitPricePerSquareMeter/cityNum ));
        }
        province.setBusinessAreaSquaMete(formatDouble(allbusinessAreaSquaMete));
        province.setOfficeAreaSquaMete(formatDouble(allofficeAreaSquaMete));
        province.setCommunicationRoomAreaSquaMete(formatDouble(allcommunicationRoomAreaSquaMete));
        province.setOtherUsageAreaSquaMete(formatDouble(allotherUsageAreaSquaMete));
        province.setChildren(orderList);
        if(orderList.size()>0){
            resultList.add(province);
        }
        int total = wzHouseLeaseInConService.queryTotal(query);
        PageUtils pageUtil = new PageUtils(resultList, total, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

    /**
     * 清单excel
     */
    @GetMapping("/excel")
    @IgnoreAuth
    public void excel(String statisticalMonth,String name,String buildingNameAlias,String city,String county, HttpServletResponse response) {
        Map<String,Object> map1=new HashMap<>();
        if(buildingNameAlias!=null){
            map1.put("buildingNameAlias",buildingNameAlias);
        }
        if(buildingNameAlias!=null){
            map1.put("statisticalMonth",statisticalMonth);
        }
        if(city!=null){
            map1.put("city",city);
        }
        if(county!=null){
            map1.put("county",county);
        }

        DateFormat df = new SimpleDateFormat("yyyyMMddHHmmss");
        ExcelExport ee1;

        //判定是闲置管理还是记录
        if(name.contains("合同管理")){
            ee1= new ExcelExport("房屋租入_合同管理" + df.format(new Date()));
            responseTab1(df,ee1,map1);
            ee1.export(response);
        }else if(name.contains("租入用途管理")){
            ee1= new ExcelExport("房屋租入_租入用途管理" + df.format(new Date()));
            responseTab2(df,ee1,map1);
            ee1.export(response);
        }else if(name.contains("租入房屋单价前10名")){
            ee1= new ExcelExport("房屋租入_租入房屋单价前10名" + df.format(new Date()));
            responseTab3(df,ee1,map1);
            ee1.export(response);
        }else if(name.contains("租入单价与平均单价比较")){
            ee1= new ExcelExport("房屋租入_租入单价与平均单价比较" + df.format(new Date()));
            responseTab4(df,ee1,map1);
            ee1.export(response);
        }else if(name.contains("租入合同记录")){
            ee1= new ExcelExport("房屋租入_租入合同记录" + df.format(new Date()));
            responseTab5(df,ee1,map1);
            ee1.export(response);
        }
    }

    public void responseTab1(DateFormat df, ExcelExport ee1, Map<String, Object> map1){
        //查询列表数据
        List<WzHouseLeaseInConEntity> wzHouseContracEntityList = wzHouseLeaseInConService.queryList(map1);

        Map<String,List<WzHouseLeaseInConEntity>> cityMap=new HashMap<>();
        for (WzHouseLeaseInConEntity leaveUseVo : wzHouseContracEntityList) {
            List<WzHouseLeaseInConEntity> list;
            if(cityMap.get(leaveUseVo.getStandardAddressLevel2())!=null){
                list=cityMap.get(leaveUseVo.getStandardAddressLevel2());
                list.add(leaveUseVo);
            }else{
                list=new ArrayList<>();
                list.add(leaveUseVo);
            }
            cityMap.put(leaveUseVo.getStandardAddressLevel2(),list);
        }

        List<WzHouseLeaseInConEntity> resultList=new ArrayList<>();
        List<WzHouseLeaseInConEntity> cityList=new ArrayList<>();

        double allContractQuantity=0l;            // 租入合同数量
        double allNoTaxContractAmount=0l;         // 合同总金额（含税）（元）
        double allRentArea=0l;                    // 总计面积（平米）
        double allUnitPricePerSquareMeter=0l;     // 每平米单价

        double allbusinessAreaSquaMete=0l;            //营业面积（平米）
        double allofficeAreaSquaMete=0l;              //办公面积（平米）
        double allcommunicationRoomAreaSquaMete=0l;  //通信机房面积（平米）
        double allotherUsageAreaSquaMete=0l;         //其他用途面积（平米）

        int cityNum=0;
        for(Map.Entry<String,List<WzHouseLeaseInConEntity>> entry:cityMap.entrySet()){
            List<WzHouseLeaseInConEntity> list=entry.getValue();

            if (list.get(0).getStandardAddressLevel3().equals("全省")) {
                continue;
            }
            //县的Map集合
            Map<String, List<WzHouseLeaseInConEntity>> countyMap = new HashMap<>();
            for (WzHouseLeaseInConEntity leaveUseVo : list) {
                if (leaveUseVo.getStandardAddressLevel3() == null || leaveUseVo.getStandardAddressLevel3().equals("")) {
                    continue;
                }
                if (countyMap.get(leaveUseVo.getStandardAddressLevel3()) != null) {
                    list = countyMap.get(leaveUseVo.getStandardAddressLevel3());
                    list.add(leaveUseVo);
                } else {
                    list = new ArrayList<>();
                    list.add(leaveUseVo);
                }
                countyMap.put(leaveUseVo.getStandardAddressLevel3(), list);
            }

            double cityContractQuantity=0l;
            double cityNoTaxContractAmount=0l;
            double cityRentArea=0l;
            double cityUnitPricePerSquareMeter=0l;

            double citybusinessAreaSquaMete=0l;            //营业面积（平米）
            double cityofficeAreaSquaMete=0l;              //办公面积（平米）
            double citycommunicationRoomAreaSquaMete=0l;  //通信机房面积（平米）
            double cityotherUsageAreaSquaMete=0l;         //其他用途面积（平米）
            List<WzHouseLeaseInConEntity> countyList=new ArrayList<>();
            for (Map.Entry<String, List<WzHouseLeaseInConEntity>> countyEntry : countyMap.entrySet()) {
                double contractQuantity=0l;
                double noTaxContractAmount=0l;
                double rentArea=0l;
                double unitPricePerSquareMeter=0l;

                double businessAreaSquaMete=0l;            //营业面积（平米）
                double officeAreaSquaMete=0l;              //办公面积（平米）
                double communicationRoomAreaSquaMete=0l;  //通信机房面积（平米）
                double otherUsageAreaSquaMete=0l;         //其他用途面积（平米）
                for (WzHouseLeaseInConEntity leaveUseVo : countyEntry.getValue()) {
                    contractQuantity+=leaveUseVo.getLeaInContracQuantity();
                    noTaxContractAmount+=leaveUseVo.getTotalContrAmount();
                    rentArea+=leaveUseVo.getTotalAreaSquaMete();
                    unitPricePerSquareMeter+=leaveUseVo.getUnitPricePerSquareMeter();
                    businessAreaSquaMete+= leaveUseVo.getBusinessAreaSquaMete();
                    officeAreaSquaMete+=leaveUseVo.getOfficeAreaSquaMete();
                    communicationRoomAreaSquaMete+=leaveUseVo.getCommunicationRoomAreaSquaMete();
                    otherUsageAreaSquaMete+=leaveUseVo.getOtherUsageAreaSquaMete();

                    cityContractQuantity+=leaveUseVo.getLeaInContracQuantity();
                    cityNoTaxContractAmount+=leaveUseVo.getTotalContrAmount();
                    cityRentArea+=leaveUseVo.getTotalAreaSquaMete();
                    cityUnitPricePerSquareMeter+=leaveUseVo.getUnitPricePerSquareMeter();
                    citybusinessAreaSquaMete+= leaveUseVo.getBusinessAreaSquaMete();
                    cityofficeAreaSquaMete+=leaveUseVo.getOfficeAreaSquaMete();
                    citycommunicationRoomAreaSquaMete+=leaveUseVo.getCommunicationRoomAreaSquaMete();
                    cityotherUsageAreaSquaMete+=leaveUseVo.getOtherUsageAreaSquaMete();

                    allContractQuantity+=leaveUseVo.getLeaInContracQuantity();
                    allNoTaxContractAmount+=leaveUseVo.getTotalContrAmount();
                    allRentArea+=leaveUseVo.getTotalAreaSquaMete();
                    allUnitPricePerSquareMeter+=leaveUseVo.getUnitPricePerSquareMeter();
                    allbusinessAreaSquaMete+= leaveUseVo.getBusinessAreaSquaMete();
                    allofficeAreaSquaMete+=leaveUseVo.getOfficeAreaSquaMete();
                    allcommunicationRoomAreaSquaMete+=leaveUseVo.getCommunicationRoomAreaSquaMete();
                    allotherUsageAreaSquaMete+=leaveUseVo.getOtherUsageAreaSquaMete();
                }
                WzHouseLeaseInConEntity wzHouseInCustomerEntity = new WzHouseLeaseInConEntity();
                wzHouseInCustomerEntity.setLeaInContracQuantity(formatDouble(contractQuantity));
                wzHouseInCustomerEntity.setStandardAddressLevel2(countyEntry.getKey());
                wzHouseInCustomerEntity.setTotalContrAmount(formatDouble(noTaxContractAmount));
                wzHouseInCustomerEntity.setTotalAreaSquaMete(formatDouble(rentArea));
                wzHouseInCustomerEntity.setUnitPricePerSquareMeter(formatDouble(unitPricePerSquareMeter));
                wzHouseInCustomerEntity.setBusinessAreaSquaMete(formatDouble(businessAreaSquaMete));
                wzHouseInCustomerEntity.setOfficeAreaSquaMete(formatDouble(officeAreaSquaMete));
                wzHouseInCustomerEntity.setCommunicationRoomAreaSquaMete(formatDouble(communicationRoomAreaSquaMete));
                wzHouseInCustomerEntity.setOtherUsageAreaSquaMete(formatDouble(otherUsageAreaSquaMete));
                countyList.add(wzHouseInCustomerEntity);
            }
            List<WzHouseLeaseInConEntity> orderCountyList=new ArrayList<>();
            try{
                //对countList 进行排序
                String city=list.get(0).getStandardAddressLevel2();
                if(city.contains("市")){
                    city=city.split("市")[0];
                }
                OtnAreaEntity area=otnAreaService.queryObject(city);
                List<OtnAreaEntity> countyAreaList=otnAreaService.getCityOption(area.getId());
                for (OtnAreaEntity otnAreaEntity : countyAreaList) {
                    for (WzHouseLeaseInConEntity wzCity : countyList) {
                        if(wzCity.getStandardAddressLevel2().contains(otnAreaEntity.getName())){
                            orderCountyList.add(wzCity);
                        }
                    }
                }
            }catch (Exception e){
                orderCountyList=countyList;
                e.printStackTrace();
            }

            WzHouseLeaseInConEntity wzHouseInCustomerEntity = new WzHouseLeaseInConEntity();
            wzHouseInCustomerEntity.setStandardAddressLevel2(entry.getKey());
            wzHouseInCustomerEntity.setLeaInContracQuantity(formatDouble(cityContractQuantity));
            wzHouseInCustomerEntity.setTotalContrAmount(formatDouble(cityNoTaxContractAmount));
            wzHouseInCustomerEntity.setTotalAreaSquaMete(formatDouble(cityRentArea));
            wzHouseInCustomerEntity.setBusinessAreaSquaMete(formatDouble(citybusinessAreaSquaMete));
            wzHouseInCustomerEntity.setOfficeAreaSquaMete(formatDouble(cityofficeAreaSquaMete));
            wzHouseInCustomerEntity.setCommunicationRoomAreaSquaMete(formatDouble(citycommunicationRoomAreaSquaMete));
            wzHouseInCustomerEntity.setOtherUsageAreaSquaMete(formatDouble(cityotherUsageAreaSquaMete));
            double num=cityUnitPricePerSquareMeter/countyMap.size();
            cityNum+=countyMap.size();
            wzHouseInCustomerEntity.setUnitPricePerSquareMeter(formatDouble(num));
            wzHouseInCustomerEntity.setChildren(orderCountyList);
            cityList.add(wzHouseInCustomerEntity);
        }


        //对cityList 进行排序
        List<OtnAreaEntity> areaList=otnAreaService.getCityOption("018");
        List<WzHouseLeaseInConEntity> orderList=new ArrayList<>();
        for (OtnAreaEntity otnAreaEntity : areaList) {
            for (WzHouseLeaseInConEntity wzCity : cityList) {
                if(wzCity.getStandardAddressLevel2().contains(otnAreaEntity.getName())){
                    orderList.add(wzCity);
                }
            }
        }

        WzHouseLeaseInConEntity province=new WzHouseLeaseInConEntity();
        province.setStandardAddressLevel2("全省");
        province.setLeaInContracQuantity(formatDouble(allContractQuantity));
        province.setTotalContrAmount(formatDouble(allNoTaxContractAmount));
        province.setTotalAreaSquaMete(formatDouble(allRentArea));
        if(cityList.size()!=0){
            province.setUnitPricePerSquareMeter(formatDouble(allUnitPricePerSquareMeter/cityNum ));
        }
        province.setBusinessAreaSquaMete(formatDouble(allbusinessAreaSquaMete));
        province.setOfficeAreaSquaMete(formatDouble(allofficeAreaSquaMete));
        province.setCommunicationRoomAreaSquaMete(formatDouble(allcommunicationRoomAreaSquaMete));
        province.setOtherUsageAreaSquaMete(formatDouble(allotherUsageAreaSquaMete));
        province.setChildren(orderList);
        resultList.add(province);


        List<Object> colList=new ArrayList();;
        List<Object[]> allList = new ArrayList();
        for (int i = 0; i < resultList.size(); i++) {

            if(resultList.get(i).getStandardAddressLevel2().contains("省")){
                colList = new ArrayList();
                colList.add(resultList.get(i).getStandardAddressLevel2());
                colList.add("");
                colList.add("");
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getLeaInContracQuantity(),false));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getTotalContrAmount(),true));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getUnitPricePerSquareMeter(),true));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getBusinessAreaSquaMete(),true));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getOfficeAreaSquaMete(),true));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getCommunicationRoomAreaSquaMete(),true));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getOtherUsageAreaSquaMete(),true));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getTotalAreaSquaMete(),true));
                allList.add(colList.toArray());

                //处理城市的
                List<WzHouseLeaseInConEntity> cityList1=resultList.get(i).getChildren();
                for (WzHouseLeaseInConEntity floorNoUserVo : cityList1) {
                    colList = new ArrayList();
                    colList.add("");
                    colList.add(floorNoUserVo.getStandardAddressLevel2());
                    colList.add("");
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getLeaInContracQuantity(),false));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getTotalContrAmount(),true));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getUnitPricePerSquareMeter(),true));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getBusinessAreaSquaMete(),true));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getOfficeAreaSquaMete(),true));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getCommunicationRoomAreaSquaMete(),true));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getOtherUsageAreaSquaMete(),true));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getTotalAreaSquaMete(),true));
                    allList.add(colList.toArray());
                    //处理县城的
                    List<WzHouseLeaseInConEntity> countyList1 = floorNoUserVo.getChildren();
                    for (WzHouseLeaseInConEntity noUserVo : countyList1) {
                        colList = new ArrayList();
                        colList.add("");
                        colList.add("");
                        colList.add(noUserVo.getStandardAddressLevel2());
                        colList.add(WzHouseMaintenaCostController.toThousands(noUserVo.getLeaInContracQuantity(),false));
                        colList.add(WzHouseMaintenaCostController.toThousands(noUserVo.getTotalContrAmount(),true));
                        colList.add(WzHouseMaintenaCostController.toThousands(noUserVo.getUnitPricePerSquareMeter(),true));
                        colList.add(WzHouseMaintenaCostController.toThousands(noUserVo.getBusinessAreaSquaMete(),true));
                        colList.add(WzHouseMaintenaCostController.toThousands(noUserVo.getOfficeAreaSquaMete(),true));
                        colList.add(WzHouseMaintenaCostController.toThousands(noUserVo.getCommunicationRoomAreaSquaMete(),true));
                        colList.add(WzHouseMaintenaCostController.toThousands(noUserVo.getOtherUsageAreaSquaMete(),true));
                        colList.add(WzHouseMaintenaCostController.toThousands(noUserVo.getTotalAreaSquaMete(),true));
                        allList.add(colList.toArray());
                    }
                }
            }
        }
        String[] header = new String[]{
                "资产所属单位(一级)",
                "资产所属单位(二级)",
                "资产所属单位(三级)",
                "租入合同数量",
                "合同年金额(含税) (元)",
                "每平米单价(元)",
                "营业面积（平米）",
                "办公面积（平米）",
                "通信机房面积(元)",
                "其他用途面积（平米）",
                "总计面积（平米）"
        };
        ee1.addSheetByArray(df.format(new Date()) + "清单", allList, header);
    }

    public void responseTab2(DateFormat df, ExcelExport ee1, Map<String, Object> map1){
        //查询列表数据
        List<WzHouseUseEntity> wzHouseContracEntityList = wzHouseUseService.queryList(map1);

        Map<String,List<WzHouseUseEntity>> cityMap=new HashMap<>();
        for (WzHouseUseEntity leaveUseVo : wzHouseContracEntityList) {
            List<WzHouseUseEntity> list;
            if(cityMap.get(leaveUseVo.getCity())!=null){
                list=cityMap.get(leaveUseVo.getCity());
                list.add(leaveUseVo);
            }else{
                list=new ArrayList<>();
                list.add(leaveUseVo);
            }
            cityMap.put(leaveUseVo.getCity(),list);
        }

        List<WzHouseUseVo> resultList=new ArrayList<>();
        List<WzHouseUseVo> cityList=new ArrayList<>();

        int allyingYe=0;
        int allbanGong=0;
        int alltongXin=0;
        int allother=0;
        int allall=0;
        for(Map.Entry<String,List<WzHouseUseEntity>> entry:cityMap.entrySet()){
            List<WzHouseUseEntity> list=entry.getValue();

            if (list.get(0).getCounty().equals("全省")) {
                continue;
            }
            //县的Map集合
            Map<String, List<WzHouseUseEntity>> countyMap = new HashMap<>();
            for (WzHouseUseEntity leaveUseVo : list) {
                if (leaveUseVo.getCounty() == null || leaveUseVo.getCounty().equals("")) {
                    continue;
                }
                if (countyMap.get(leaveUseVo.getCounty()) != null) {
                    list = countyMap.get(leaveUseVo.getCounty());
                    list.add(leaveUseVo);
                } else {
                    list = new ArrayList<>();
                    list.add(leaveUseVo);
                }
                countyMap.put(leaveUseVo.getCounty(), list);
            }

            int cityyingYe=0;
            int citybanGong=0;
            int citytongXin=0;
            int cityother=0;
            int cityall=0;
            List<WzHouseUseVo> countyList=new ArrayList<>();
            for (Map.Entry<String, List<WzHouseUseEntity>> countyEntry : countyMap.entrySet()) {
                int yingYe=0;
                int banGong=0;
                int tongXin=0;
                int other=0;
                int all=0;
                for (WzHouseUseEntity leaveUseVo : countyEntry.getValue()) {
                    if(leaveUseVo.getRentalUse()!=null){
                        if(leaveUseVo.getRentalUse().equals("通信设施机房")){
                            tongXin+=1;
                            citytongXin+=1;
                            alltongXin+=1;
                        }
                        else if(leaveUseVo.getRentalUse().equals("营业")){
                            yingYe+=1;
                            cityyingYe+=1;
                            allyingYe+=1;
                        }
                        else if(leaveUseVo.getRentalUse().equals("其他租入用途")){
                            other+=1;
                            cityother+=1;
                            allother+=1;
                        }
                        else if(leaveUseVo.getRentalUse().equals("办公")){
                            banGong+=1;
                            citybanGong+=1;
                            allbanGong+=1;
                        }
                        all+=1;
                        cityall+=1;
                        allall+=1;
                    }
                }
                WzHouseUseVo wzHouseInCustomerEntity = new WzHouseUseVo();
                wzHouseInCustomerEntity.setYingYe(yingYe);
                wzHouseInCustomerEntity.setCity(countyEntry.getKey());
                wzHouseInCustomerEntity.setBanGong(banGong);
                wzHouseInCustomerEntity.setAll(all);
                wzHouseInCustomerEntity.setTongXin(tongXin);
                wzHouseInCustomerEntity.setOther(other);
                countyList.add(wzHouseInCustomerEntity);
            }
            List<WzHouseUseVo> orderCountyList=new ArrayList<>();
            try{
                //对countList 进行排序
                String city=list.get(0).getCity();
                if(city.contains("市")){
                    city=city.split("市")[0];
                }
                OtnAreaEntity area=otnAreaService.queryObject(city);
                List<OtnAreaEntity> countyAreaList=otnAreaService.getCityOption(area.getId());
                for (OtnAreaEntity otnAreaEntity : countyAreaList) {
                    for (WzHouseUseVo wzCity : countyList) {
                        if(wzCity.getCity().contains(otnAreaEntity.getName())){
                            orderCountyList.add(wzCity);
                        }
                    }
                }
            }catch (Exception e){
                orderCountyList=countyList;
                e.printStackTrace();
            }

            WzHouseUseVo wzHouseInCustomerEntity = new WzHouseUseVo();
            wzHouseInCustomerEntity.setCity(entry.getKey());
            wzHouseInCustomerEntity.setYingYe(cityyingYe);
            wzHouseInCustomerEntity.setBanGong(citybanGong);
            wzHouseInCustomerEntity.setAll(cityall);
            wzHouseInCustomerEntity.setTongXin(citytongXin);
            wzHouseInCustomerEntity.setOther(cityother);
            wzHouseInCustomerEntity.setChildren(orderCountyList);
            cityList.add(wzHouseInCustomerEntity);
        }


        //对cityList 进行排序
        List<OtnAreaEntity> areaList=otnAreaService.getCityOption("018");
        List<WzHouseUseVo> orderList=new ArrayList<>();
        for (OtnAreaEntity otnAreaEntity : areaList) {
            for (WzHouseUseVo wzCity : cityList) {
                if(wzCity.getCity().contains(otnAreaEntity.getName())){
                    orderList.add(wzCity);
                }
            }
        }

        WzHouseUseVo province=new WzHouseUseVo();
        province.setCity("全省");
        province.setYingYe(allyingYe);
        province.setBanGong(allbanGong);
        province.setAll(allall);
        province.setTongXin(alltongXin);
        province.setOther(allother);
        province.setChildren(orderList);
        resultList.add(province);

        List<Object> colList=new ArrayList();;
        List<Object[]> allList = new ArrayList();
        for (int i = 0; i < resultList.size(); i++) {

            if(resultList.get(i).getCity().contains("省")){
                colList = new ArrayList();
                colList.add(resultList.get(i).getCity());
                colList.add("");
                colList.add("");
                colList.add(resultList.get(i).getYingYe());
                colList.add(resultList.get(i).getBanGong());
                colList.add(resultList.get(i).getTongXin());
                colList.add(resultList.get(i).getOther());
                colList.add(resultList.get(i).getAll());
                allList.add(colList.toArray());

                //处理城市的
                List<WzHouseUseVo> cityList1=resultList.get(i).getChildren();
                for (WzHouseUseVo floorNoUserVo : cityList1) {
                    colList = new ArrayList();
                    colList.add("");
                    colList.add(floorNoUserVo.getCity());
                    colList.add("");
                    colList.add(floorNoUserVo.getYingYe());
                    colList.add(floorNoUserVo.getBanGong());
                    colList.add(floorNoUserVo.getTongXin());
                    colList.add(floorNoUserVo.getOther());
                    colList.add(floorNoUserVo.getAll());
                    allList.add(colList.toArray());
                    //处理县城的
                    List<WzHouseUseVo> countyList1 = floorNoUserVo.getChildren();
                    for (WzHouseUseVo noUserVo : countyList1) {
                        colList = new ArrayList();
                        colList.add("");
                        colList.add("");
                        colList.add(noUserVo.getCity());
                        colList.add(noUserVo.getYingYe());
                        colList.add(noUserVo.getBanGong());
                        colList.add(noUserVo.getTongXin());
                        colList.add(noUserVo.getOther());
                        colList.add(noUserVo.getAll());
                        allList.add(colList.toArray());
                    }
                }
            }
        }
        String[] header = new String[]{
                "资产所属单位(一级)",
                "资产所属单位(二级)",
                "资产所属单位(三级)",
                "营业",
                "办公",
                "通信设施机房",
                "其他租入用途",
                "总计"
        };
        ee1.addSheetByArray(df.format(new Date()) + "清单", allList, header);

    }

    public void responseTab3(DateFormat df, ExcelExport ee1, Map<String, Object> map1){

        List<WzHouseContractTopEntity> resultList = wzHouseContractTopService.queryList(map1);

        List<Object> colList=new ArrayList();;
        List<Object[]> allList = new ArrayList();
        for (int i = 0; i < resultList.size(); i++) {
            colList = new ArrayList();
            colList.add(resultList.get(i).getCity());
            colList.add(resultList.get(i).getCounty());
            colList.add(resultList.get(i).getUseTheProLine());
            colList.add(resultList.get(i).getLeaseInPracticalUse());
            colList.add(resultList.get(i).getDescriptionOfOtherUsesOfTheLease());
            colList.add(resultList.get(i).getCityArea());
            colList.add(resultList.get(i).getDistrict());
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getContractAmountIncludingTax(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getRentalBuildingArea(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getHireTime(),false));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getTotalMonthlyRent(),true));
            colList.add(resultList.get(i).getContractNumber());
            colList.add(resultList.get(i).getContractName());
            allList.add(colList.toArray());
        }
        String[] header = new String[]{
                "使用单位隶属的地市级公司",
                "使用单位隶属的区县级公司",
                "使用专业线",
                "租入实际用途",
                "租入其他用途说明",
                "城市区域",
                "地段",
                "合同总金额(含税)(元)",
                "租入建筑面积(平米)",
                "租期（年）",
                "每平米月租金",
                "合同编号",
                "合同名称"
        };
        ee1.addSheetByArray(df.format(new Date()) + "清单", allList, header);
    }

    public void responseTab4(DateFormat df, ExcelExport ee1, Map<String, Object> map1){
        List<WzHouseContractCompareEntity> resultList = wzHouseContractCompareService.queryList(map1);

        List<Object> colList=new ArrayList();;
        List<Object[]> allList = new ArrayList();
        for (int i = 0; i < resultList.size(); i++) {
            colList = new ArrayList();
            colList.add(resultList.get(i).getCity());
            colList.add(resultList.get(i).getCounty());
            colList.add(resultList.get(i).getUseTheProLine());
            colList.add(resultList.get(i).getLeaseInPracticalUse());
            colList.add(resultList.get(i).getDescriptionOfOtherUsesOfTheLease());
            colList.add(resultList.get(i).getCityArea());
            colList.add(resultList.get(i).getDistrict());
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getContractAmountIncludingTax(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getRentalBuildingArea(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getHireTime(),false));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getTotalMonthlyRent(),true));
            colList.add(resultList.get(i).getContractNumber());
            colList.add(resultList.get(i).getContractName());
            allList.add(colList.toArray());
        }
        String[] header = new String[]{
                "使用单位隶属的地市级公司",
                "使用单位隶属的区县级公司",
                "使用专业线",
                "租入实际用途",
                "租入其他用途说明",
                "城市区域",
                "地段",
                "合同总金额(含税)(元)",
                "租入建筑面积(平米)",
                "租期（年）",
                "每平米月租金",
                "合同编号",
                "合同名称"
        };
        ee1.addSheetByArray(df.format(new Date()) + "清单", allList, header);
    }

    public void responseTab5(DateFormat df, ExcelExport ee1, Map<String, Object> map1){

        List<WzHouseContractInEntity> resultList = wzHouseContractInService.queryList(map1);

        List<Object> colList=new ArrayList();;
        List<Object[]> allList = new ArrayList();
        for (int i = 0; i < resultList.size(); i++) {
            colList = new ArrayList();
            colList.add(resultList.get(i).getImportTime());
            colList.add(resultList.get(i).getInvestmentEntities());
            colList.add(resultList.get(i).getTheNameOfTheRentedProperty());
            colList.add(resultList.get(i).getFormOfLease());
            colList.add(resultList.get(i).getStandardAddressLevel_1());
            colList.add(resultList.get(i).getStandardAddressLevel_2());
            colList.add(resultList.get(i).getStandardAddressLevel_3());
            colList.add(resultList.get(i).getHouseNumber());
            colList.add(resultList.get(i).getCityArea());
            colList.add(resultList.get(i).getDistrict());
            colList.add(resultList.get(i).getBuildingLongitude());
            colList.add(resultList.get(i).getBuildingDimension());
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getRentalBuildingArea(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getRentalUsableArea(),true));
            colList.add(resultList.get(i).getInvestmentEntities());
            colList.add(resultList.get(i).getUseTheUnitsHierarchy());
            colList.add(resultList.get(i).getCity());
            colList.add(resultList.get(i).getCounty());
            colList.add(resultList.get(i).getUseTheProLine());
            colList.add(resultList.get(i).getLeaseInPracticalUse());
            colList.add(resultList.get(i).getDescriptionOfOtherUsesOfTheLease());
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getSelfUseBuildingArea(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getSubleaseBuildingArea(),true));
            colList.add(resultList.get(i).getFirstHireTime());
            colList.add(resultList.get(i).getUseDepartments());
            colList.add(resultList.get(i).getContacts());
            colList.add(resultList.get(i).getContactNumber());
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getTotalMonthlyRent(),true));
            colList.add(resultList.get(i).getContractNumber());
            colList.add(resultList.get(i).getContractName());
            colList.add(resultList.get(i).getContractType());
            colList.add(resultList.get(i).getSignTime());
            colList.add(resultList.get(i).getOurContractingEntity());
            colList.add(resultList.get(i).getLessorName());
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getContractAmountIncludingTax(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getValueAddedTaxAmount(),true));
            colList.add(resultList.get(i).getEffectiveTimeOfContract());
            colList.add(resultList.get(i).getTerminationTimeOfContract());
            colList.add(resultList.get(i).getUndertakingDepartment());
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getSelfUseArea(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getIdleUseArea(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getRentalUseArea(),true));
            colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getRentalUsableArea(),true));
            allList.add(colList.toArray());
        }
        String[] header = new String[]{
                "导入时间",
                "房屋所有权人属性",
                "租入房屋名称",
                "租入形式",
                "标准地址(一级)",
                "标准地址(二级)",
                "标准地址(三级)",
                "街/路/村门牌号",
                "城市区域",
                "地段",
                "地址经度坐标",
                "地址纬度坐标",
                "租入建筑面积(平米)",
                "租入使用面积(平米)",
                "投资主体",
                "使用单位层级",
                "使用单位隶属的省级公司",
                "使用单位隶属的地市级公司",
                "使用单位隶属的区县级公司",
                "使用专业线",
                "租入实际用途",
                "租入其他用途说明",
                "自用建筑面积(平米)",
                "转租建筑面积(平米)",
                "首次租用时间",
                "使用部门",
                "联系人",
                "联系电话",
                "月租金(不含税)(元)",
                "合同编号",
                "合同名称",
                "合同类型",
                "签订时间",
                "我方签约主体",
                "出租方名称",
                "合同总金额(含税)(元)",
                "增值税金额(元)",
                "租入开始时间(合同生效时间)",
                "租入终止时间(合同终止时间)",
                "承办部门",
                "自用面积（使用）",
                "闲置面积（使用）",
                "出租面积（使用）",
                "不可使用面积（使用）"
        };
        ee1.addSheetByArray(df.format(new Date()) + "清单", allList, header);
    }

    public double formatDouble(double num){
        double avera=0l;
        try{
            DecimalFormat format2 = new DecimalFormat("#.00");
            String str2 = format2.format(num);
            avera = Double.parseDouble(str2);
        }catch (Exception e){
            e.printStackTrace();
        }
        return avera;
    }

}
