package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.OtnAreaEntity;
import com.example.entity.WzHouseContracEntity;
import com.example.entity.WzScoreRankingEntity;
import com.example.entity.WzScoreVo;
import com.example.entity.vo.housemanager.LeaveUseVo;
import com.example.service.WzBuildManageDetailsService;
import com.example.service.WzHouseContracService;
import com.example.service.WzHouseMaintenaCostService;
import com.example.service.WzOtnAreaService;
import com.example.service.WzScoreRankingService;
import com.example.utils.PageMap;
import com.example.utils.PageUtils;
import com.example.utils.Query;
import com.example.utils.R;
import com.example.utils.excel.ExcelExport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 房屋出租(合同管理)
 */
@RestController
@RequestMapping("/house-car/house/dist/api/wzScoreRanking")
public class WzScoreRankingController {

    @Autowired
    private WzScoreRankingService wzScoreRankingService;

    @Autowired
    private WzOtnAreaService otnAreaService;

    @Autowired
    private WzBuildManageDetailsService wzBuildManageDetailsService;
    @Autowired
    private WzHouseContracService wzHouseContracService;
    @Autowired
    private WzHouseMaintenaCostService wzHouseMaintenaCostService;

    @RequestMapping("/list")
    @IgnoreAuth
    public R list(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        Query query1 = new Query(pageMap);
        Query query2 = new Query(pageMap);
        //闲置率
        List<LeaveUseVo> ideaRateList=wzBuildManageDetailsService.queryLeaveUseList(query);
        //出租欠费率
        List<WzHouseContracEntity> rentArreList=wzHouseContracService.dealHouseContracList(query1);
        //维修
        List<WzScoreVo> scoreList= wzHouseMaintenaCostService.queryDailyModifyByScore(query2);

        List<LeaveUseVo> ideaList=new ArrayList<>();
        if(ideaRateList.size()>0){
            ideaList=ideaRateList.get(0).getChildren();
        }
        List<WzHouseContracEntity> rentList=new ArrayList<>();
        if(rentArreList.size()>0){
            rentList   =rentArreList.get(0).getChildren();
        }
        List<WzScoreVo> scoreVoList=new ArrayList<>();
        if(scoreList.size()>0){
            scoreVoList=scoreList.get(0).getChildren();
            if(rentList.size()>0){
                scoreList.get(0).setUnitPricePerSquareMeter(rentList.get(0).getUnitPricePerSquareMeter());
                scoreList.get(0).setRArrearsRate(rentList.get(0).getAverage());
            }
           if(ideaList.size()>0){
               scoreList.get(0).setIdleRate(ideaList.get(0).getAverage());
               scoreList.get(0).setRAbleRate(ideaList.get(0).getRentAverage());
           }
        }
        for (WzScoreVo wzScoreVo : scoreVoList) {
            for(LeaveUseVo useVo:ideaList){
                if(wzScoreVo.getCity().equals(useVo.getCity())){
                    wzScoreVo.setIdleRate(useVo.getAverage());
                    wzScoreVo.setRAbleRate(useVo.getRentAverage());
                    break;
                }
            }
            for(WzHouseContracEntity con:rentList){
                if(wzScoreVo.getCity().equals(con.getCity())){
                    wzScoreVo.setRArrearsRate(con.getAverage());
                    wzScoreVo.setUnitPricePerSquareMeter(con.getUnitPricePerSquareMeter());
                    break;
                }
            }
        }
        PageUtils pageUtil = new PageUtils(scoreList, 0, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }



    @RequestMapping("/echartList")
    @IgnoreAuth
    public R echartList(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        List<WzScoreRankingEntity> list = wzScoreRankingService.queryList(query);
        List<WzScoreRankingEntity> allList=new ArrayList<>();
        for (WzScoreRankingEntity wzScoreRankingEntity : list) {
            if(wzScoreRankingEntity.getCity()!=null){
                allList.add(wzScoreRankingEntity);
            }
        }
        //对cityList 进行排序
        List<OtnAreaEntity> areaList=otnAreaService.getCityOption("018");
        List<WzScoreRankingEntity> orderList=new ArrayList<>();
        for (OtnAreaEntity otnAreaEntity : areaList) {
            for (WzScoreRankingEntity wzCity : allList) {
                if(wzCity.getCity().contains(otnAreaEntity.getName())){
                    orderList.add(wzCity);
                }
            }
        }
        PageUtils pageUtil = new PageUtils(orderList, 0, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

    /**
     * 清单excel
     */
    @GetMapping("/excel")
    @IgnoreAuth
    public void excel(String name,String statisticalMonth,String city,String county, HttpServletResponse response) {
        Map<String,Object> map0=new HashMap<>();
        Map<String,Object> map1=new HashMap<>();
        Map<String,Object> map2=new HashMap<>();
        if(statisticalMonth!=null){
            map0.put("statisticalMonth",statisticalMonth);
            map1.put("statisticalMonth",statisticalMonth);
            map2.put("statisticalMonth",statisticalMonth);
        }
        if(city!=null){
            map0.put("city",city);
            map1.put("city",city);
            map2.put("city",city);
        }
        if(county!=null){
            map0.put("county",county);
            map1.put("county",county);
            map2.put("county",county);
        }

        DateFormat df = new SimpleDateFormat("yyyyMMddHHmmss");
        ExcelExport ee1;

        //判定是闲置管理还是记录
        if(name.contains("综合评价总分排名")){
            ee1 = new ExcelExport("综合评价总分排名" + df.format(new Date()));
            responseTab1(df,ee1,map0,map1,map2);
            ee1.export(response);
        }else{
            ee1 = new ExcelExport("综合评价总分排名" + df.format(new Date()));
            responseTab1(df,ee1,map0,map1,map2);
            ee1.export(response);
        }
    }

    public void responseTab1(DateFormat df, ExcelExport ee1, Map<String, Object> map0, Map<String, Object> map1, Map<String, Object> map2){

        //闲置率
        List<LeaveUseVo> ideaRateList=wzBuildManageDetailsService.queryLeaveUseList(map0);
        //出租欠费率
        List<WzHouseContracEntity> rentArreList=wzHouseContracService.dealHouseContracList(map1);
        //维修
        List<WzScoreVo> resultList= wzHouseMaintenaCostService.queryDailyModifyByScore(map2);

        List<LeaveUseVo> ideaList=new ArrayList<>();
        if(ideaRateList.size()>0){
            ideaList=ideaRateList.get(0).getChildren();
        }
        List<WzHouseContracEntity> rentList=new ArrayList<>();
        if(rentArreList.size()>0){
            rentList   =rentArreList.get(0).getChildren();
        }
        List<WzScoreVo> scoreVoList=new ArrayList<>();
        if(resultList.size()>0){
            scoreVoList=resultList.get(0).getChildren();
            if(rentList.size()>0){
                resultList.get(0).setUnitPricePerSquareMeter(rentList.get(0).getUnitPricePerSquareMeter());
                resultList.get(0).setRArrearsRate(rentList.get(0).getAverage());
            }
            if(ideaList.size()>0){
                resultList.get(0).setIdleRate(ideaList.get(0).getAverage());
                resultList.get(0).setRAbleRate(ideaList.get(0).getRentAverage());
            }
        }
        for (WzScoreVo wzScoreVo : scoreVoList) {
            for(LeaveUseVo useVo:ideaList){
                if(wzScoreVo.getCity().equals(useVo.getCity())){
                    wzScoreVo.setIdleRate(useVo.getAverage());
                    wzScoreVo.setRAbleRate(useVo.getRentAverage());
                    break;
                }
            }
            for(WzHouseContracEntity con:rentList){
                if(wzScoreVo.getCity().equals(con.getCity())){
                    wzScoreVo.setRArrearsRate(con.getAverage());
                    wzScoreVo.setUnitPricePerSquareMeter(con.getUnitPricePerSquareMeter());
                    break;
                }
            }
        }

        List<Object> colList=new ArrayList();;
        List<Object[]> allList = new ArrayList();
        for (int i = 0; i < resultList.size(); i++) {

            if(resultList.get(i).getCity().contains("省")){
                colList = new ArrayList();
                colList.add(resultList.get(i).getCity());
                colList.add("");
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getIdleRate(),true)+"%");
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getRAbleRate(),true)+"%");
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getRArrearsRate(),true)+"%");
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getUnitPricePerSquareMeter(),true));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getDailyNum(),false));
                colList.add(WzHouseMaintenaCostController.toThousands(resultList.get(i).getHighNum(),false));
                allList.add(colList.toArray());

                //处理城市的
                List<WzScoreVo> cityList1=resultList.get(i).getChildren();
                for (WzScoreVo floorNoUserVo : cityList1) {
                    colList = new ArrayList();
                    colList.add("");
                    colList.add(floorNoUserVo.getCity());
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getIdleRate(),true)+"%");
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getRAbleRate(),true)+"%");
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getRArrearsRate(),true)+"%");
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getUnitPricePerSquareMeter(),true));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getDailyNum(),false));
                    colList.add(WzHouseMaintenaCostController.toThousands(floorNoUserVo.getHighNum(),false));
                    allList.add(colList.toArray());

                }
            }
        }
        String[] header = new String[]{
                "资产所属单位(一级)",
                "资产所属单位(二级)",
                "闲置率=出/(出+闲)",
                "可出租率=(出+闲)/(自+出+闲)",
                "出租欠费率=欠费合同/合同总数",
                "每平方单价=不含税总价/租期/面积",
                "大于万元零星维修次数",
                "高频(大于每月1次)维修建筑数",
                "总分",
                "排名"
        };
        ee1.addSheetByArray(df.format(new Date()) + "清单", allList, header);
    }


}
