package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.WzUserEntity;
import com.example.service.WzUserService;
import com.example.utils.PageMap;
import com.example.utils.PageUtils;
import com.example.utils.Query;
import com.example.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 房屋出租(合同管理)
 */
@RestController
@RequestMapping("/house-car/house/dist/api/wzUser")
public class WzUserController {

    @Autowired
    private WzUserService wzUserService;

    @RequestMapping("/list")
    @IgnoreAuth
    public R list(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        List<WzUserEntity> list = wzUserService.queryList(query);
        Query query1 = new Query(pageMap);
        int total = wzUserService.queryTotal(query1);
        PageUtils pageUtil = new PageUtils(list, total, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

        /**
    * 保存
    */
    @RequestMapping("/save")
    @IgnoreAuth
    public R save(@RequestBody WzUserEntity bBizItem) {
        wzUserService.save(bBizItem);
        return R.ok();
    }

}
