package com.example.controller.house;

import com.example.config.annotation.IgnoreAuth;
import com.example.pojo.dto.HouseDataImportDto;
import com.example.service.house.HouseDataImportService;
import com.example.utils.R;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;

@Tag(name = "不动产数据导入")
@RestController
@RequestMapping("/house-car/house/dist/api/data-import")
public class HouseDataImportController {
    private final HouseDataImportService houseDataImportService;

    public HouseDataImportController(HouseDataImportService houseDataImportService) {
        this.houseDataImportService = houseDataImportService;
    }

    @IgnoreAuth
    @Operation(summary = "获取不动产数据导入模板")
    @PostMapping("/getTemplates")
    public R getTemplates() {
        return houseDataImportService.getTemplates();
    }

    @IgnoreAuth
    @Operation(summary = "导入数据")
    @PostMapping("/dataImport")
    public R dataImport(@Valid HouseDataImportDto dto, @RequestPart("file") MultipartFile file) {
        return houseDataImportService.dataImport(dto, file);
    }
}
