package com.example.controller.house;

import com.example.common.Rsp;
import com.example.pojo.dto.GetSiteStatDto;
import com.example.pojo.vo.GetSiteStatVo;
import com.example.service.house.HouseSiteStatService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@Tag(name = "不动产一房产局址一表")
@Slf4j
@RequestMapping("/house-car/house/dist/api/siteStat")
@RestController
public class HouseSiteStatController {
    private final HouseSiteStatService houseSiteStatService;

    public HouseSiteStatController(HouseSiteStatService houseSiteStatService) {
        this.houseSiteStatService = houseSiteStatService;
    }

    @Operation(summary = "查询一房产局址一表")
    @PostMapping("/getSiteStat")
    public Rsp<GetSiteStatVo> getSiteStat(@Valid @RequestBody GetSiteStatDto dto) {
        return houseSiteStatService.getSiteStat(dto);
    }

    @Operation(summary = "一房产局址一表导出")
    @GetMapping("/siteStatExport")
    public void siteStatExport(@Valid GetSiteStatDto.GetSiteStatMapDTO dto) {
        houseSiteStatService.siteStatExport(dto);
    }
}
