package com.example.controller.house;

import com.example.common.PageVo;
import com.example.common.Rsp;
import com.example.pojo.dto.BuildingOfficeAreaStatDto;
import com.example.pojo.vo.BuildingOfficeAreaStatVo;
import com.example.service.house.HouseWzBuildmanageAvageareaService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@Tag(name = "自有房产人均办公面积")
@Slf4j
@RestController
@RequestMapping("/house-car/house/dist/api/WzBuildmanageAvagearea")
public class HouseWzBuildmanageAvageareaController {
    private final HouseWzBuildmanageAvageareaService houseWzBuildmanageAvageareaService;

    public HouseWzBuildmanageAvageareaController(HouseWzBuildmanageAvageareaService houseWzBuildmanageAvageareaService) {
        this.houseWzBuildmanageAvageareaService = houseWzBuildmanageAvageareaService;
    }

    @Operation(summary = "查询自有房产人均办公面积")
    @PostMapping("/list")
    public Rsp<PageVo<BuildingOfficeAreaStatVo>> buildingOfficeAreaStat(@Valid @RequestBody BuildingOfficeAreaStatDto dto) {
        return houseWzBuildmanageAvageareaService.buildingOfficeAreaStat(dto);
    }

    @Operation(summary = "自有房产人均办公面积导出")
    @GetMapping("/buildingOfficeAreaStatExport")
    public void buildingOfficeAreaStatExport(@Valid BuildingOfficeAreaStatDto.BuildingOfficeAreaStatMapDTO dto) {
        houseWzBuildmanageAvageareaService.buildingOfficeAreaStatExport(dto);
    }
}
