package com.example.controller.house;

import com.example.common.PageVo;
import com.example.common.Rsp;
import com.example.pojo.dto.LandIdleStatDto;
import com.example.pojo.dto.ListLandDto;
import com.example.pojo.dto.ListSiteNameDto;
import com.example.pojo.dto.ListSiteNumDto;
import com.example.pojo.vo.LandIdleStatVo;
import com.example.pojo.vo.ListLandVo;
import com.example.service.house.HouseWzLandManageDetailsService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@Tag(name = "不动产土地")
@RestController
@RequestMapping("/house-car/house/dist/api/WzLandManageDetails")
public class HouseWzLandManageDetailsController {
    private final HouseWzLandManageDetailsService houseWzLandManageDetailsService;

    public HouseWzLandManageDetailsController(HouseWzLandManageDetailsService houseWzLandManageDetailsService) {
        this.houseWzLandManageDetailsService = houseWzLandManageDetailsService;
    }

    @Operation(summary = "查询局址别名列表")
    @PostMapping("/getBuildingNameAlias")
    public Rsp<PageVo<String>> listSiteName(@RequestBody ListSiteNameDto dto) {
        return houseWzLandManageDetailsService.listSiteName(dto);
    }

    @Operation(summary = "查询局址编号列表")
    @PostMapping("/getBuildingNameCode")
    public Rsp<PageVo<String>> listSiteNum(@RequestBody ListSiteNumDto dto) {
        return houseWzLandManageDetailsService.listSiteNum(dto);
    }

    @Operation(summary = "查询闲置管理")
    @PostMapping("/list")
    public Rsp<PageVo<LandIdleStatVo>> buildingIdleStat(@Valid @RequestBody LandIdleStatDto dto) {
        return houseWzLandManageDetailsService.landIdleStat(dto);
    }

    @Operation(summary = "闲置管理导出")
    @GetMapping("/landIdleStatExport")
    public void landIdleStatExport(@Valid LandIdleStatDto.LandIdleStatMapDTO dto) {
        houseWzLandManageDetailsService.landIdleStatExport(dto);
    }

    @Operation(summary = "查询土地记录")
    @PostMapping("/queryLandDetail")
    public Rsp<PageVo<ListLandVo>> queryLandDetail(@Valid @RequestBody ListLandDto dto) {
        return houseWzLandManageDetailsService.queryLandDetail(dto);
    }

    @Operation(summary = "土地记录导出")
    @GetMapping("/queryLandDetailExport")
    public void queryLandDetailExport(@Valid ListLandDto.ListLandMapDTO dto) {
        houseWzLandManageDetailsService.queryLandDetailExport(dto);
    }
}
