package com.example.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.io.Serializable;

/**
 * 房屋管理
 */
@Data
public class WzHouseMarketEntity implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    private Integer id;
    private String city;
    private String county;
    private String buildingId;    //建筑ID
    private String buildingAlias;    //建筑别名
    private String buildingAddress;    //地址
    private String contractNumber;    //合同号
    private String leaseCategory;  //租赁类别
    private String contractLeaseTerm;   //合同租期（月数）
    private String contractRentalArea;  //合同出租面积
    private String totalMonthlyRent;    //月租金（元）
    private String surveyTime;           //调查时间
    private String buildingLongitude;    //房屋经度
    private String buildingDimension;    //房屋纬度
    private String marketBuildingName;  //市场建筑名

    private String distanceBetweenBuildings;  //建筑之间距离m
    private String marketContractLeaseTerm;   //市场合同租期（月数）
    private String marketContractRentalArea;  //市场合同出租面积
    private String monthlyRent;    //月租金（元）
    private String marketStandardAddress;    //市场标准地址
    private String housingRentCollectionMethod;    //房屋租金收取方式
    private String propertyType;    //物业类型
    private String totalNumberOfFloors;  //楼层总数
    private String renovationSituation;    //装修
    private String contractAmountExcludeTax; //不含增值税合同额
    private String unitPriceMonth;         //每平米单价
    private String marketUnitPriceMonth;  //市场每平米单价月
    private String marketUnitPriceDay;    //市场每平米单价天
    private String hasNearbyProperty; //1.5公里内是否有类似物业
    private String noNearbyPropertyReason; //没有类似物业原因
}
