package com.example.entity.house;

import lombok.Data;

import java.math.BigDecimal;

@Data
public class BuildingRepairMonthPo {
    /**
     * 数据年月
     */
    private Integer yearMonth;

    /**
     * 建筑ID
     */
    private String buildingId;

    /**
     * 建筑id维修
     */
    private String jzJzid;

    /**
     * 资产所属单位(一级)
     */
    private String firstUnit;

    /**
     * 资产所属单位(二级)
     */
    private String secondUnit;

    /**
     * 资产所属单位(三级)
     */
    private String thirdUnit;

    /**
     * 局址编号
     */
    private String siteNum;

    /**
     * 局址别名
     */
    private String siteName;

    /**
     * 维修类型
     */
    private String repairType;

    /**
     * 维修内容分类
     */
    private String contentCategory;

    /**
     * 决算金额
     */
    private BigDecimal finalCost;

    /**
     * 标准地址
     */
    private String address;

    /**
     * 城市等级
     */
    private String cityLevel;

    /**
     * 城市区域
     */
    private String cityRegion;

    /**
     * 地段
     */
    private String areaSector;

    /**
     * 是否有土地资产
     */
    private String hasLand;

    /**
     * 局址ID
     */
    private String siteId;

    /**
     * 建筑别名
     */
    private String buildingName;

    /**
     * 得房率
     */
    private BigDecimal housingAcquisitionRate;

    /**
     * 房屋来源
     */
    private String housingSource;

    /**
     * 取得日期
     */
    private String acquisitionDate;

    /**
     * 房龄开始年份
     */
    private Integer houseYearBegan;

    /**
     * 投资主体
     */
    private String investorName;

    /**
     * 管理层级
     */
    private String managementLevel;

    /**
     * 房屋结构
     */
    private String buildingStructure;

    /**
     * 楼层总数
     */
    private String totalFloors;

    /**
     * 资产编号
     */
    private String assetsNum;

    /**
     * 资产标签号
     */
    private String assetsTagNum;

    /**
     * 使用状态
     */
    private String usageStatus;

    /**
     * 建筑用途
     */
    private String buildingUse;

    /**
     * 权属状态
     */
    private String ownershipStatus;

    /**
     * 建筑占地面积(㎡)
     */
    private BigDecimal floorArea;

    /**
     * 建筑面积(㎡)
     */
    private BigDecimal buildingArea;

    /**
     * 建筑面积-自用(㎡)
     */
    private BigDecimal buildingAreaSelfUse;

    /**
     * 建筑面积-出租(㎡)
     */
    private BigDecimal buildingAreaRent;

    /**
     * 建筑面积-闲置(㎡)
     */
    private BigDecimal buildingAreaIdle;

    /**
     * 建筑面积-不可使用(㎡)
     */
    private BigDecimal buildingAreaUnusable;

    /**
     * 使用面积(㎡)
     */
    private BigDecimal usableArea;

    /**
     * 使用面积-自用(㎡)
     */
    private BigDecimal usableAreaSelfUse;

    /**
     * 使用面积-出租(㎡)
     */
    private BigDecimal usableAreaRent;

    /**
     * 使用面积-闲置(㎡)
     */
    private BigDecimal usableAreaIdle;

    /**
     * 使用面积-不可使用(㎡)
     */
    private BigDecimal usableAreaUnusable;

    /**
     * 二级组织机构编码
     */
    private String areaNo;

    /**
     * 二级组织机构名称
     */
    private String areaName;

    /**
     * 三级组织机构编码
     */
    private String cityNo;

    /**
     * 三级组织机构名称
     */
    private String cityName;

    /**
     * 房龄
     */
    private Integer houseAge;

    /**
     * 每平米维修单价
     */
    private BigDecimal repairUnitPrice;
}
