package com.example.entity.house;

import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Data
public class BuildingRepairStatPo {
    /**
     * 二级组织机构编码
     */
    private String areaNo;
    /**
     * 二级组织机构名称
     */
    private String areaName;
    /**
     * 三级组织机构编码
     */
    private String cityNo;
    /**
     * 三级组织机构名称
     */
    private String cityName;
    /**
     * 项目制维修
     */
    private BigDecimal xmz;
    /**
     * 零星维修
     */
    private BigDecimal lx;
    /**
     * 应急维修
     */
    private BigDecimal yj;
    /**
     * 合计
     */
    private BigDecimal hj;
    /**
     * 子列表
     */
    private List<BuildingRepairStatPo> children;

    public BuildingRepairStatPo() {
        this.areaNo = "";
        this.areaName = "";
        this.cityNo = "";
        this.cityName = "";
        this.xmz = BigDecimal.ZERO;
        this.lx = BigDecimal.ZERO;
        this.yj = BigDecimal.ZERO;
        this.hj = BigDecimal.ZERO;
        this.children = new ArrayList<>();
    }

    public BuildingRepairStatPo(String areaNo, String areaName) {
        this.areaNo = areaNo;
        this.areaName = areaName;
        this.cityNo = areaNo;
        this.cityName = areaName;
        this.xmz = BigDecimal.ZERO;
        this.lx = BigDecimal.ZERO;
        this.yj = BigDecimal.ZERO;
        this.hj = BigDecimal.ZERO;
        this.children = new ArrayList<>();
    }

    public void update(BuildingRepairStatPo po) {
        this.xmz = this.xmz.add(po.xmz);
        this.lx = this.lx.add(po.lx);
        this.yj = this.yj.add(po.yj);
        this.hj = this.hj.add(po.hj);
        this.children.add(po);
    }
}
