package com.example.entity.house;

import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@NoArgsConstructor
@Data
public class HouseBuildingHighRepairPo {
    /**
     * 账期
     */
    private Integer yearMonth;
    /**
     * 建筑id
     */
    private String buildingId;
    /**
     * 最近维修年月
     */
    private Integer latestRepairMonth;
    /**
     * 二级组织机构编码
     */
    private String areaNo;
    /**
     * 二级组织机构名称
     */
    private String areaName;
    /**
     * 三级组织机构编码
     */
    private String cityNo;
    /**
     * 三级组织机构名称
     */
    private String cityName;
    /**
     * 建筑别名
     */
    private String buildingName;
    /**
     * 维修类型
     */
    private String repairType;
    /**
     * 维修类容分类
     */
    private String contentCategory;
    /**
     * 累计维修
     */
    private BigDecimal finalCostSum;
    /**
     * 标准地址
     */
    private String address;
    /**
     * 建筑用途
     */
    private String buildingUse;
    /**
     * 建筑面积(㎡)
     */
    private BigDecimal buildingArea;
    /**
     * 建筑面积-自用(㎡)
     */
    private BigDecimal buildingAreaSelfUse;
    /**
     * 建筑面积-出租(㎡)
     */
    private BigDecimal buildingAreaRent;
    /**
     * 建筑面积-闲置(㎡)
     */
    private BigDecimal buildingAreaIdle;
    /**
     * 建筑面积-不可使用(㎡)
     */
    private BigDecimal buildingAreaUnusable;
    /**
     * 局址id
     */
    private String siteId;
    /**
     * 局址编号
     */
    private String siteNum;
    /**
     * 局址别名
     */
    private String siteName;
}
