package com.example.entity.house;

import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@NoArgsConstructor
@Data
public class HouseLandPo {
    /**
     * 数据年月
     */
    private Integer yearMonth;

    /**
     * 资产所属单位(一级)
     */
    private String firstUnit;

    /**
     * 资产所属单位(二级)
     */
    private String secondUnit;

    /**
     * 资产所属单位(三级)
     */
    private String thirdUnit;

    /**
     * 土地别名
     */
    private String landName;

    /**
     * 土地ID
     */
    private String landId;

    /**
     * 土地性质
     */
    private String landOwnership;

    /**
     * 使用权类型
     */
    private String useRightType;

    /**
     * 地类用途
     */
    private String landUse;

    /**
     * 取得日期
     */
    private String acquisitionDate;

    /**
     * 闲置开始时间
     */
    private String idleStartDate;

    /**
     * 局址编号
     */
    private String siteNum;

    /**
     * 局址别名
     */
    private String siteName;

    /**
     * 局址ID
     */
    private String siteId;

    /**
     * 标准地址
     */
    private String address;

    /**
     * 投资主体
     */
    private String investor;

    /**
     * 管理层级
     */
    private String managementLevel;

    /**
     * 权属状态
     */
    private String ownershipStatus;

    /**
     * 使用状态
     */
    private String usageStatus;

    /**
     * 土地总面积(㎡)
     */
    private BigDecimal totalLandArea;

    /**
     * 土地自用面积(㎡)
     */
    private BigDecimal landAreaSelfUse;

    /**
     * 土地闲置面积(㎡)
     */
    private BigDecimal landAreaIdle;

    /**
     * 土地出租面积(㎡)
     */
    private BigDecimal landAreaRent;

    /**
     * 土地不可使用面积(㎡)
     */
    private BigDecimal landAreaUnusable;

    /**
     * 是否有土地证
     */
    private String hasLandDeed;

    /**
     * 无土地证原因
     */
    private String noLandDeedReason;

    /**
     * 是否有保地风险
     */
    private String landPreservationRisk;

    /**
     * 是否空地
     */
    private String openSpace;

    /**
     * 是否有院落
     */
    private String courtyard;

    /**
     * 未关联资产
     */
    private String unrelatedAssets;

    /**
     * 资产编号
     */
    private String assetsNum;

    /**
     * 资产标签号
     */
    private String assetsTagNum;

    /**
     * 责任部门
     */
    private String responsibleDepartment;

    /**
     * 责任人
     */
    private String personInCharge;

    /**
     * 经度集团
     */
    private BigDecimal lngJt;

    /**
     * 纬度集团
     */
    private BigDecimal latJt;

    /**
     * 实际产权人
     */
    private String propertyOwner;

    /**
     * 特殊说明
     */
    private String specialSpecification;

    /**
     * 二级组织机构编码
     */
    private String areaNo;

    /**
     * 二级组织机构名称
     */
    private String areaName;

    /**
     * 三级组织机构编码
     */
    private String cityNo;

    /**
     * 三级组织机构名称
     */
    private String cityName;

    /**
     * 地市id
     */
    private String cityId;

    /**
     * 地市
     */
    private String city;

    /**
     * 区县id
     */
    private String districtId;

    /**
     * 区县
     */
    private String district;
}
