package com.example.enums;

public enum ListBuildingRepairMonthOrderEnum {
    /**
     * 一级单位
     */
    province("first_unit"),
    /**
     * 二级单位
     */
    city("area_name"),
    /**
     * 三级单位
     */
    county("city_name"),
    /**
     * 建筑id基本信息
     */
    buildingId("building_id"),
    /**
     * 建筑id维修
     */
    jzJzid("jz_jzid"),
    /**
     * 入账日期
     */
    statisticalMonth("year_month"),
    /**
     * 维修类型
     */
    repairType("repair_type"),
    /**
     * 维修内容
     */
    repairContent("content_category"),
    /**
     * erp入账金额元
     */
    erpCreditedAmount("final_cost"),
    /**
     * 每平方米维修单价
     */
    averagePrice("repair_unit_price"),
    /**
     * 局址编号
     */
    buildingAddressNumber("site_num"),
    /**
     * 局址别名
     */
    buildingNnameAlias("site_name"),
    /**
     * 标准地址
     */
    standardAddress("address"),
    /**
     * 城市等级
     */
    cityGrade("city_level"),
    /**
     * 城市区域
     */
    cityArea("city_region"),
    /**
     * 投资主体
     */
    investmentEntity("investor_name"),
    /**
     * 管理层级
     */
    managementHierarchy("management_level"),
    /**
     * 房屋结构
     */
    buildingStructure("building_structure"),
    /**
     * 使用状态
     */
    useState("usage_status"),
    /**
     * 建筑用途
     */
    buildingUse("building_use"),
    /**
     * 权属状态
     */
    ownershipStatus("ownership_status"),
    /**
     * 建筑别名
     */
    buildingAias("building_name"),
    /**
     * 建筑占地面积(㎡)
     */
    buildingFloorArea("floor_area"),
    /**
     * 建筑面积
     */
    buildingArea("building_area"),
    /**
     * 建筑面积自用
     */
    buildingAreaUseArea("building_area_self_use"),
    /**
     * 建筑面积出租
     */
    buildingAreaRentArea("building_area_rent"),
    /**
     * 建筑面积闲置
     */
    buildingAreaIdelArea("building_area_idle"),
    /**
     * 建筑面积不可使用
     */
    buildingAreaUnavailable("building_area_unusable"),
    /**
     * 使用面积(㎡)
     */
    useArea("usable_area"),
    /**
     * 使用面积-自用(㎡)
     */
    useAreaSelfUseArea("usable_area_self_use"),
    /**
     * 使用面积-出租(㎡)
     */
    useAreaRentArea("usable_area_rent"),
    /**
     * 使用面积-闲置(㎡)
     */
    useAreaIdelArea("usable_area_idle"),
    /**
     * 使用面积-不可使用(㎡)
     */
    useAreaUnavailableArea("usable_area_unusable"),
    /**
     * 得房率
     */
    housingAcquisitionRate("housing_acquisition_rate"),
    /**
     * 房屋来源
     */
    housingSource("housing_source"),
    /**
     * 取得日期
     */
    acquisitionDate("acquisition_date"),
    /**
     * 房龄开始年份
     */
    houseYearBegan("house_year_began"),
    /**
     * 房龄
     */
    houseAge("house_age"),
    /**
     * 楼层总数
     */
    totalFloors("total_floors"),
    /**
     * 资产编号
     */
    assetsNum("assets_num"),
    /**
     * 资产标签号
     */
    assetsTagNum("assets_tag_num"),
    /**
     * 地段
     */
    areaSector("area_sector"),
    /**
     * 是否有土地资产
     */
    hasLand("has_land"),
    /**
     * 局址id
     */
    siteId("site_id"),
    ;

    private final String columnName;

    ListBuildingRepairMonthOrderEnum(String columnName) {
        this.columnName = columnName;
    }

    public String getColumnName() {
        return columnName;
    }
}
