package com.example.enums;

public enum ListLandOrderEnum {
    /**
     * 一级单位
     */
    province("first_unit"),
    /**
     * 二级单位
     */
    city("area_name"),
    /**
     * 三级单位
     */
    county("city_name"),
    /**
     * 局址别名
     */
    buildingNameAlias("site_name"),
    /**
     * 局址编号
     */
    buildingAddressNumber("site_num"),
    /**
     * 土地别名
     */
    landAlias("land_name"),
    /**
     * 土地性质
     */
    landNature("land_ownership"),
    /**
     * 使用权类型
     */
    usageRightsType("use_right_type"),
    /**
     * 地类用途
     */
    landUse("land_use"),
    /**
     * 取得日期
     */
    getDate("acquisition_date"),
    /**
     * 闲置开始时间
     */
    idelLandBegindate("idle_start_date"),
    /**
     * 标准地址
     */
    standardAddress("address"),
    /**
     * 投资主体
     */
    investmentEntity("investor"),
    /**
     * 管理层级
     */
    managementHierarchy("management_level"),
    /**
     * 权属状态
     */
    ownershipStatus("ownership_status"),
    /**
     * 使用状态
     */
    useState("usage_status"),
    /**
     * 土地总面积
     */
    totalLandArea("total_land_area"),
    /**
     * 土地自用面积
     */
    landSelfUseArea("land_area_self_use"),
    /**
     * 土地闲置面积
     */
    landIdelUseArea("land_area_idle"),
    /**
     * 土地出租面积
     */
    landRentUseArea("land_area_rent"),
    /**
     * 土地不可使用面积
     */
    lanNoUnavailableArea("land_area_unusable"),
    /**
     * 是否有土地证
     */
    landCertificate("has_land_deed"),
    /**
     * 无土地证原因
     */
    noLandCertificateReason("no_land_deed_reason"),
    /**
     * 是否有保地风险
     */
    protectLandRisk("land_preservation_risk"),
    /**
     * 是否空地
     */
    clearingLand("open_space"),
    /**
     * 是否有院落
     */
    courtyard("courtyard"),
    /**
     * 未关联资产
     */
    unrelatedAssets("unrelated_assets"),
    /**
     * 资产编号
     */
    assetCode("assets_num"),
    /**
     * 资产标签号
     */
    astsLabe("assets_tag_num"),
    /**
     * 责任部门
     */
    responsibleDepartment("responsible_department"),
    /**
     * 责任人
     */
    responsiblePerson("person_in_charge"),
    /**
     * 经度集团
     */
    buildingLongitude("lng_jt"),
    /**
     * 纬度集团
     */
    buildingDimension("lat_jt"),
    /**
     * 实际产权人
     */
    buildingActualPropertyOwner("property_owner"),
    /**
     * 特殊说明
     */
    specialInstructions("special_specification"),
    ;

    private final String columnName;

    ListLandOrderEnum(String columnName) {
        this.columnName = columnName;
    }

    public String getColumnName() {
        return columnName;
    }
}
