package com.example.pojo.dto;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.util.StringUtils;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.net.URLDecoder;
import java.nio.charset.StandardCharsets;

@NoArgsConstructor
@Data
public class BuildingRepairStatDto {
    @Valid
    @NotNull
    private BuildingRepairStatMapDTO map;

    @NoArgsConstructor
    @Data
    public static class BuildingRepairStatMapDTO {
        @Schema(description = "账期", example = "202312")
        @NotNull
        private Integer statisticalMonth1;
        @Schema(description = "二级组织机构id")
        private String city;
        @Schema(description = "三级级组织机构id")
        private String county;
        @Schema(description = "投资主体")
        private String investmentEntity;
    }

    public BuildingRepairStatDto(BuildingRepairStatMapDTO map) {
        if (StringUtils.hasText(map.city)) {
            map.city = URLDecoder.decode(map.city, StandardCharsets.UTF_8);
        }
        if (StringUtils.hasText(map.county)) {
            map.county = URLDecoder.decode(map.county, StandardCharsets.UTF_8);
        }
        if (StringUtils.hasText(map.investmentEntity)) {
            map.investmentEntity = URLDecoder.decode(map.investmentEntity, StandardCharsets.UTF_8);
        }
        this.map = map;
    }
}
