package com.example.pojo.vo;

import com.example.entity.house.BuildingIdleStatPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Data
public class BuildingIdleStatVo {
    @Schema(description = "单位名称")
    private String city;
    @Schema(description = "闲置数量")
    private Integer idelNum;
    @Schema(description = "建筑面积")
    private BigDecimal buildingArea;
    @Schema(description = "建筑面积自用")
    private BigDecimal buildingAreaUseArea;
    @Schema(description = "建筑面积出租")
    private BigDecimal buildingAreaRentArea;
    @Schema(description = "建筑面积闲置")
    private BigDecimal buildingAreaIdelArea;
    @Schema(description = "闲置率")
    private BigDecimal average;
    @Schema(description = "子列表")
    private List<BuildingIdleStatVo> children;
    @Schema(description = "是否变色")
    private Boolean flag;

    public BuildingIdleStatVo(BuildingIdleStatPo po, Boolean flag) {
        this.city = po.getCityName();
        this.idelNum = po.getIdleCount();
        this.buildingArea = po.getBuildingAreaSum();
        this.buildingAreaUseArea = po.getBuildingAreaSelfUseSum();
        this.buildingAreaRentArea = po.getBuildingAreaRentSum();
        this.buildingAreaIdelArea = po.getBuildingAreaIdleSum();
        if (po.getIdlePercent() != null) {
            this.average = po.getIdlePercent().multiply(new BigDecimal("100"));
        }
        this.flag = flag;
        this.children = new ArrayList<>();
        List<BuildingIdleStatPo> list = po.getChildren();
        int size = list.size();
        for (int i = 0; i < size; i++) {
            BuildingIdleStatPo t = list.get(i);
            this.children.add(new BuildingIdleStatVo(t, flag == (i % 2 != 0)));
        }
    }
}
