package com.example.pojo.vo;

import com.example.entity.house.BuildingOfficeAreaStatPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Data
public class BuildingOfficeAreaStatVo {
    @Schema(description = "单位名称")
    private String city;
    @Schema(description = "办公面积")
    private BigDecimal officeArea;
    @Schema(description = "员工数")
    private Integer employees;
    @Schema(description = "人均办公面积")
    private BigDecimal average;
    private List<BuildingOfficeAreaStatVo> children;
    @Schema(description = "是否变色")
    private Boolean flag;

    public BuildingOfficeAreaStatVo(BuildingOfficeAreaStatPo po, Boolean flag) {
        this.city = po.getCityName();
        this.officeArea = po.getBuildingAreaSelfUseSum();
        this.employees = po.getTotal();
        this.average = po.getAreaAvg();
        this.flag = flag;
        this.children = new ArrayList<>();
        List<BuildingOfficeAreaStatPo> list = po.getChildren();
        int size = list.size();
        for (int i = 0; i < size; i++) {
            BuildingOfficeAreaStatPo t = list.get(i);
            this.children.add(new BuildingOfficeAreaStatVo(t, flag == (i % 2 != 0)));
        }
    }
}
