package com.example.pojo.vo;

import com.example.entity.house.BuildingRepairStatPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Data
public class BuildingRepairStatVo {
    @Schema(description = "单位名称")
    private String city;
    @Schema(description = "项目制维修")
    private BigDecimal projectCost;
    @Schema(description = "零星维修")
    private BigDecimal smallCost;
    @Schema(description = "应急维修")
    private BigDecimal warnCost;
    @Schema(description = "总计")
    private BigDecimal allCost;
    @Schema(description = "是否变色")
    private Boolean flag;
    private List<BuildingRepairStatVo> children;

    public BuildingRepairStatVo(BuildingRepairStatPo po, Boolean flag) {
        this.city = po.getCityName();
        this.projectCost = po.getXmz();
        this.smallCost = po.getLx();
        this.warnCost = po.getYj();
        this.allCost = po.getHj();
        this.flag = flag;
        this.children = new ArrayList<>();
        List<BuildingRepairStatPo> list = po.getChildren();
        int size = list.size();
        for (int i = 0; i < size; i++) {
            BuildingRepairStatPo t = list.get(i);
            this.children.add(new BuildingRepairStatVo(t, flag == (i % 2 != 0)));
        }
    }
}
