package com.example.pojo.vo;

import com.example.entity.house.HouseAgeStatPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@NoArgsConstructor
@Data
public class HouseAgeStatVo {
    @Schema(description = "二级单位名称")
    private String city;
    @Schema(description = "三级单位名称")
    private String county;
    @Schema(description = "1-10年")
    private Integer oneLevelYear;
    @Schema(description = "11-20年")
    private Integer twoLevelYear;
    @Schema(description = "21-30年")
    private Integer thrLevelYear;
    @Schema(description = "31-40年")
    private Integer fouLevelYear;
    @Schema(description = "41-50年")
    private Integer fivLevelYear;
    @Schema(description = "50年以上")
    private Integer sixLevelYear;
    @Schema(description = "平均房龄")
    private BigDecimal average;
    @Schema(description = "是否变色")
    private Boolean flag;
    @Schema(description = "子列表")
    private List<HouseAgeStatVo> children;
    @Schema(description = "未知房龄")
    private Integer au;
    @Schema(description = "建筑总数")
    private Integer total;
    @Schema(description = "房龄合计")
    private Integer houseAgeSum;

    public HouseAgeStatVo(HouseAgeStatPo po, Boolean flag) {
        this.city = po.getAreaName();
        this.county = po.getCityName();
        this.oneLevelYear = po.getA1();
        this.twoLevelYear = po.getA2();
        this.thrLevelYear = po.getA3();
        this.fouLevelYear = po.getA4();
        this.fivLevelYear = po.getA5();
        this.sixLevelYear = po.getA6();
        this.average = po.getHouseAgeAvg();
        this.flag = flag;
        this.au = po.getAu();
        this.total = po.getTotal();
        this.houseAgeSum = po.getHouseAgeSum();
        this.children = new ArrayList<>();
        List<HouseAgeStatPo> list = po.getChildren();
        int size = list.size();
        for (int i = 0; i < size; i++) {
            HouseAgeStatPo t = list.get(i);
            this.children.add(new HouseAgeStatVo(t, flag == (i % 2 != 0)));
        }
    }
}