package com.example.pojo.vo;

import com.example.entity.house.HouseBuildingHighSporadicRepairPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class ListBuildingHighSporadicRepairVo {
    @Schema(description = "二级单位")
    private String city;
    @Schema(description = "维修内容")
    private String repairContent;
    @Schema(description = "维修类型")
    private String repairType;
    @Schema(description = "维修金额")
    private BigDecimal erpMoney;
    @Schema(description = "本年超1万元次数")
    private Integer num;
    @Schema(description = "维修年月")
    private Integer date;
    @Schema(description = "建筑别名")
    private String buildingAlias;
    @Schema(description = "局址编号")
    private String siteNum;
    @Schema(description = "局址别名")
    private String siteName;

    public ListBuildingHighSporadicRepairVo(HouseBuildingHighSporadicRepairPo po) {
        this.city = po.getAreaName();
        this.repairContent = po.getRepairContent();
        this.repairType = po.getRepairType();
        this.erpMoney = po.getAmount();
        this.num = po.getTotal();
        this.date = po.getRepairYearMonth();
        this.buildingAlias = po.getBuildingName();
        this.siteNum = po.getSiteNum();
        this.siteName = po.getSiteName();
    }
}
