package com.example.pojo.vo;

import com.example.entity.house.BuildingRepairMonthPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.text.DecimalFormat;

@Data
@NoArgsConstructor
public class ListBuildingRepairMonthVo {
    @Schema(description = "建筑id基本信息")
    private String buildingId;
    @Schema(description = "建筑id维修")
    private String jzJzid;
    @Schema(description = "入账日期")
    private Integer statisticalMonth;
    @Schema(description = "维修类型")
    private String repairType;
    @Schema(description = "维修内容")
    private String repairContent;
    @Schema(description = "erp入账金额元")
    private BigDecimal erpCreditedAmount;
    @Schema(description = "每平方米维修单价")
    private BigDecimal averagePrice;
    @Schema(description = "资产所属单位一级")
    private String province;
    @Schema(description = "资产所属单位二级")
    private String city;
    @Schema(description = "资产所属单位三级")
    private String county;
    @Schema(description = "局址编号")
    private String buildingAddressNumber;
    @Schema(description = "局址别名")
    private String buildingNnameAlias;
    @Schema(description = "标准地址")
    private String standardAddress;
    @Schema(description = "城市等级")
    private String cityGrade;
    @Schema(description = "城市区域")
    private String cityArea;
    @Schema(description = "地段")
    private String areaSector;
    @Schema(description = "是否有土地资产")
    private String hasLand;
    @Schema(description = "局址id")
    private String siteId;
    @Schema(description = "建筑别名")
    private String buildingName;
    @Schema(description = "得房率")
    private String housingAcquisitionRate;
    @Schema(description = "房屋来源")
    private String housingSource;
    @Schema(description = "取得日期")
    private String acquisitionDate;
    @Schema(description = "房龄开始年份")
    private Integer houseYearBegan;
    @Schema(description = "投资主体")
    private String investmentEntity;
    @Schema(description = "管理层级")
    private String managementHierarchy;
    @Schema(description = "房屋结构")
    private String buildingStructure;
    @Schema(description = "楼层总数")
    private String totalFloors;
    @Schema(description = "资产编号")
    private String assetsNum;
    @Schema(description = "资产标签号")
    private String assetsTagNum;
    @Schema(description = "使用状态")
    private String useState;
    @Schema(description = "建筑用途")
    private String buildingUse;
    @Schema(description = "权属状态")
    private String ownershipStatus;
    @Schema(description = "建筑占地面积")
    private BigDecimal buildingFloorArea;
    @Schema(description = "建筑面积")
    private BigDecimal buildingArea;
    @Schema(description = "建筑面积自用")
    private BigDecimal buildingAreaUseArea;
    @Schema(description = "建筑面积出租")
    private BigDecimal buildingAreaRentArea;
    @Schema(description = "建筑面积闲置")
    private BigDecimal buildingAreaIdelArea;
    @Schema(description = "建筑面积不可使用")
    private BigDecimal buildingAreaUnavailable;
    @Schema(description = "使用面积")
    private BigDecimal useArea;
    @Schema(description = "使用面积自用")
    private BigDecimal useAreaSelfUseArea;
    @Schema(description = "使用面积出租")
    private BigDecimal useAreaRentArea;
    @Schema(description = "使用面积闲置")
    private BigDecimal useAreaIdelArea;
    @Schema(description = "使用面积不可使用")
    private BigDecimal useAreaUnavailableArea;
    @Schema(description = "房龄")
    private Integer houseAge;

    public ListBuildingRepairMonthVo(BuildingRepairMonthPo po) {
        this.buildingId = po.getBuildingId();
        this.jzJzid = po.getJzJzid();
        this.statisticalMonth = po.getYearMonth();
        this.repairType = po.getRepairType();
        this.repairContent = po.getContentCategory();
        this.erpCreditedAmount = po.getFinalCost();
        this.averagePrice = po.getRepairUnitPrice();
        this.province = po.getFirstUnit();
        this.city = po.getAreaName();
        this.county = po.getCityName();
        this.buildingAddressNumber = po.getSiteNum();
        this.buildingNnameAlias = po.getSiteName();
        this.standardAddress = po.getAddress();
        this.cityGrade = po.getCityLevel();
        this.cityArea = po.getCityRegion();
        this.areaSector = po.getAreaSector();
        this.hasLand = po.getHasLand();
        this.siteId = po.getSiteId();
        this.buildingName = po.getBuildingName();
        this.housingAcquisitionRate = po.getHousingAcquisitionRate() != null
                ? new DecimalFormat("#.00%").format(po.getHousingAcquisitionRate()) : null;
        this.housingSource = po.getHousingSource();
        this.acquisitionDate = po.getAcquisitionDate();
        this.houseYearBegan = po.getHouseYearBegan();
        this.investmentEntity = po.getInvestorName();
        this.managementHierarchy = po.getManagementLevel();
        this.buildingStructure = po.getBuildingStructure();
        this.totalFloors = po.getTotalFloors();
        this.assetsNum = po.getAssetsNum();
        this.assetsTagNum = po.getAssetsTagNum();
        this.useState = po.getUsageStatus();
        this.buildingUse = po.getBuildingUse();
        this.ownershipStatus = po.getOwnershipStatus();
        this.buildingFloorArea = po.getFloorArea();
        this.buildingArea = po.getBuildingArea();
        this.buildingAreaUseArea = po.getBuildingAreaSelfUse();
        this.buildingAreaRentArea = po.getBuildingAreaRent();
        this.buildingAreaIdelArea = po.getBuildingAreaIdle();
        this.buildingAreaUnavailable = po.getBuildingAreaUnusable();
        this.useArea = po.getUsableArea();
        this.useAreaSelfUseArea = po.getUsableAreaSelfUse();
        this.useAreaRentArea = po.getUsableAreaRent();
        this.useAreaIdelArea = po.getUsableAreaIdle();
        this.useAreaUnavailableArea = po.getUsableAreaUnusable();
        this.houseAge = po.getHouseAge();
    }
}
