package com.example.pojo.vo;

import com.example.entity.house.HouseBuildingSameRepairFrequencyPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

@Data
public class ListBuildingSameRepairFrequencyVo {
    @Schema(description = "账期", example = "202312")
    private Integer time;
    @Schema(description = "维修类型")
    private String repairType;
    @Schema(description = "资产所属单位二级")
    private String city;
    @Schema(description = "建筑别名")
    private String buildingAlias;
    @Schema(description = "本年维修频率")
    private Integer num;
    @Schema(description = "排名")
    private Integer order;
    @Schema(description = "建筑id")
    private String buildingId;
    @Schema(description = "维修内容")
    private String contentCategory;
    @Schema(description = "历史累计维修频率")
    private Integer historyTotal;
    @Schema(description = "局址编号")
    private String siteNum;
    @Schema(description = "局址别名")
    private String siteName;

    public ListBuildingSameRepairFrequencyVo(HouseBuildingSameRepairFrequencyPo po) {
        this.buildingId = po.getBuildingId();
        this.time = po.getYearMonth();
        this.repairType = po.getRepairType();
        this.contentCategory = po.getContentCategory();
        this.city = po.getAreaName();
        this.buildingAlias = po.getBuildingName();
        this.num = po.getTyTotal();
        this.order = po.getTyTotalRank();
        this.historyTotal = po.getHistoryTotal();
        this.siteNum = po.getSiteNum();
        this.siteName = po.getSiteName();
    }
}
