package com.example.pojo.vo;

import com.example.entity.house.HouseLandPo;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Data
@NoArgsConstructor
public class ListLandVo {
    @Schema(description = "资产所属单位(一级)")
    private String province;
    @Schema(description = "资产所属单位(二级)")
    private String city;
    @Schema(description = "资产所属单位(三级)")
    private String county;
    @Schema(description = "土地别名")
    private String landAlias;
    @Schema(description = "土地性质")
    private String landNature;
    @Schema(description = "使用权类型")
    private String usageRightsType;
    @Schema(description = "地类用途")
    private String landUse;
    @Schema(description = "取得日期")
    private String getDate;
    @Schema(description = "闲置开始时间")
    private String idelLandBegindate;
    @Schema(description = "局址别名")
    private String buildingNameAlias;
    @Schema(description = "标准地址")
    private String standardAddress;
    @Schema(description = "投资主体")
    private String investmentEntity;
    @Schema(description = "管理层级")
    private String managementHierarchy;
    @Schema(description = "权属状态")
    private String ownershipStatus;
    @Schema(description = "使用状态")
    private String useState;
    @Schema(description = "土地总面积(㎡)")
    private BigDecimal totalLandArea;
    @Schema(description = "土地自用面积(㎡)")
    private BigDecimal landSelfUseArea;
    @Schema(description = "土地闲置面积(㎡)")
    private BigDecimal landIdelUseArea;
    @Schema(description = "土地出租面积(㎡)")
    private BigDecimal landRentUseArea;
    @Schema(description = "土地不可使用面积(㎡)")
    private BigDecimal lanNoUnavailableArea;
    @Schema(description = "是否有土地证")
    private String landCertificate;
    @Schema(description = "无土地证原因")
    private String noLandCertificateReason;
    @Schema(description = "是否有保地风险")
    private String protectLandRisk;
    @Schema(description = "是否空地")
    private String clearingLand;
    @Schema(description = "是否有院落")
    private String courtyard;
    @Schema(description = "未关联资产")
    private String unrelatedAssets;
    @Schema(description = "资产编号")
    private String assetCode;
    @Schema(description = "资产标签号")
    private String astsLabe;
    @Schema(description = "责任部门")
    private String responsibleDepartment;
    @Schema(description = "部门人")
    private String responsiblePerson;
    @Schema(description = "房屋经度")
    private BigDecimal buildingLongitude;
    @Schema(description = "房屋纬度")
    private BigDecimal buildingDimension;
    @Schema(description = "实际产权人")
    private String buildingActualPropertyOwner;
    @Schema(description = "特殊说明")
    private String specialInstructions;
//    @Schema(description = "使用面积-闲置(㎡)")
//    private String useAreaIdelArea;
//    @Schema(description = "使用面积-不可使用(㎡)")
//    private String useAreaUnavailableArea;
//    @Schema(description = "楼长姓名")
//    private String landManageName;
//    @Schema(description = "楼长所在单位")
//    private String landManageCompany;
//    @Schema(description = "土地经度")
//    private BigDecimal landLongitude;
//    @Schema(description = "土地纬度")
//    private BigDecimal landDimension;
//    @Schema(description = "土地实际产权人")
//    private String landActualPropertyOwner;
    @Schema(description = "局址编码")
    private String buildingAddressNumber;

    public ListLandVo(HouseLandPo po) {
        this.province = po.getFirstUnit();
        this.city = po.getAreaName();
        this.county = po.getCityName();
        this.landAlias = po.getLandName();
        this.landNature = po.getLandOwnership();
        this.usageRightsType = po.getUseRightType();
        this.landUse = po.getLandUse();
        this.getDate = po.getAcquisitionDate();
        this.idelLandBegindate = po.getIdleStartDate();
        this.buildingNameAlias = po.getSiteName();
        this.standardAddress = po.getAddress();
        this.investmentEntity = po.getInvestor();
        this.managementHierarchy = po.getManagementLevel();
        this.ownershipStatus = po.getOwnershipStatus();
        this.useState = po.getUsageStatus();
        this.totalLandArea = po.getTotalLandArea();
        this.landSelfUseArea = po.getLandAreaSelfUse();
        this.landIdelUseArea = po.getLandAreaIdle();
        this.landRentUseArea = po.getLandAreaRent();
        this.lanNoUnavailableArea = po.getLandAreaUnusable();
        this.landCertificate = po.getHasLandDeed();
        this.noLandCertificateReason = po.getNoLandDeedReason();
        this.protectLandRisk = po.getLandPreservationRisk();
        this.clearingLand = po.getOpenSpace();
        this.courtyard = po.getCourtyard();
        this.unrelatedAssets = po.getUnrelatedAssets();
        this.assetCode = po.getAssetsNum();
        this.astsLabe = po.getAssetsTagNum();
        this.responsibleDepartment = po.getResponsibleDepartment();
        this.responsiblePerson = po.getPersonInCharge();
        this.buildingActualPropertyOwner = po.getPropertyOwner();
        this.specialInstructions = po.getSpecialSpecification();
        this.buildingLongitude = po.getLngJt();
        this.buildingDimension = po.getLatJt();
        this.buildingAddressNumber = po.getSiteNum();
    }
}
