package com.example.service.common;

import com.example.dao.common.RequestLogDao;
import com.example.entity.common.RequestLogPo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ConcurrentLinkedQueue;

@Slf4j
@Service
public class RequestLogService {
    public static final ConcurrentLinkedQueue<RequestLogPo> QUEUE = new ConcurrentLinkedQueue<>();
    private final RequestLogDao requestLogDao;

    public RequestLogService(RequestLogDao requestLogDao) {
        this.requestLogDao = requestLogDao;
    }

    public void offer(RequestLogPo requestLog) {
        QUEUE.offer(requestLog);
    }

    @PostConstruct
    public void consumer() {
        CompletableFuture.runAsync(() -> {
            while (true) {
                try {
                    RequestLogPo requestLogPo = QUEUE.poll();
                    if (requestLogPo != null) {
                        requestLogDao.insert(requestLogPo);
                    }
                } catch (Exception e) {
                    log.error(e.getMessage(), e);
                }
            }
        });
    }
}
